'// Typelist example
#include once "../fbList.bi"

print ".Fill can be used to quickly generate lists"

'// Create a new list type named IntList that can hold integers
TypeList IntList Holds integer

'// Create a list off of our TYPELIST
dim as IntList myList

myList.Fill(5, 4) '// Fill with 4 items containing the number 5, no 'index' means append to end

print "	myList after .Fill(5, 4):"
print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list
'//			5, 5, 5, 5
print
print " .Fill does not overwrite and behaves like .Insert"

myList.Fill(1, 2, 2) '// Fill with 2 items containing the number 1 starting at index 2

print "	myList after .Fill(1, 2, 2):"
print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list
'//			5, 5, 1, 1, 5, 5
print

print " .Fill can be passed arrays and other lists. The passed array or list will wrap around if 'len' is longer"
dim as integer fillerArray(...) = {1, 2, 3}

myList.Clear() '// Clear the list
myList.Fill(fillerArray(), 7) '// Fill with an array

print "	myList after .Fill(array(), 7):"
print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list
'//			1, 2, 3, 1, 2, 3, 1
print

dim as IntList fillerList = fillerArray()

myList.Clear() '// Clear the list
myList.Fill(fillerList, 7) '// Fill with a list

print "	myList after .Fill(list, 7):"
print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list
'//			1, 2, 3, 1, 2, 3, 1


print
print "Press any key to close the example!"
sleep
