'// Typelist example
#include once "../fbList.bi"

print ".Sequence can be used to quickly generate custom lists"

'// Create a new list type named IntList that can hold integers
TypeList IntList Holds integer

'// Create a list off of our TYPELIST
dim as IntList myList

print " .Sequence behaves just like .Fill but have a function pointer parameter that is called to generate values"
function mySequence(byval listIndex as integer, byval sequenceCount as integer) as integer '// Return value MUST match the list type
	return (listIndex + 1) ^ 2
end function

myList.Sequence(@mySequence, 5, 0) '// Insert a 5 long sequence starting at index 0. If there is no index Sequence appends to the end

print "	myList after .Sequence( , 5, 0):"
print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list
'//			5, 5, 1, 40, 50, 60, 70, 80, 1, 5, 5
print

#ifdef IntList.ListIsNumeric '// Is COMPILE-TIME defined for any list of type BYTE, UBYTE, SINGLE, DOUBLE, SHORT, USHORT, LONG, ULONG, LONGINT, ULONGINT, INTEGER, UINTEGER
	print " There are some built-in default numeric methods for .Sequence (Only available for standard numeric types!)"
	myList.Clear()
	myList.IntSequence(5)
	print "	myList after .IntSequence(5):"
	print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list
	'//			1, 2, 3, 4, 5
	print
	
	myList.Clear()
	myList.PoTSequence(5)
	print "	myList after .PoTSequence(5):"
	print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list
	'//			1, 2, 4, 8, 16
	print
	
	myList.Clear()
	myList.OddSequence(5)
	print "	myList after .OddSequence(5):"
	print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list
	'//			1, 3, 5, 7, 9
	print
	
	myList.Clear()
	myList.EvenSequence(5)
	print "	myList after .EvenSequence(5):"
	print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list
	'//			1, 2, 4, 8, 16
	print
#endif


print
print "Press any key to close the example!"
sleep
