'// Typelist example
#include once "../fbList.bi"

print "Lists can be sorted manually by using the .Sort() method"

'// Create an array of numbers
dim as integer ScrambledNumbers(...) = {8, 6, 5, 7, 4}

'// Create a new list type named IntList that can hold integers
TypeList IntList Holds integer

'// Create a list off of our TYPELIST and fill it with the numbers we defined above
dim as IntList myList = ScrambledNumbers()

print "	Before .Sort():"
print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list

myList.Sort()

print "	After .Sort():"
print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list


myList += 2 '// Insert 2 into the list

print "	After inserting '2', note that the list is no longer sorted:"
print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list
print

print " By using .SortedInsert() we can force a list to sort:"

myList.SortedInsert(3) '// Insert 3 into the list

print "	After .SortedInsert(3), note that the list is now sorted:"
print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list
print

myList.Clear( ScrambledNumbers() ) '// Reset the list for the below examples

print " For lists that should always be sorted using .EnableSort() makes all operations sorted"
print "  Note that .EnableSort() makes the 'index' parameter of methods ignored!"

myList.EnableSort() '// Enable forced-automatic sorting

print " Any list operation will be automatically sorted from this point on until .DisableSort() is called on the list."
print " However, .EnableSort() itself does not sort the list."
print
print "	After .EnableSort(), note that .EnableSort() itself does not sort the list:"
print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list

myList += 1 '// Insert 1 into the list

print "	After inserting '1', the list is sorted because of .EnableSort():"
print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list
print

print " The .CustomSort() method can be used to set a custom sort method:"
function myCustomReverseSort(byref a as integer, byref b as integer) as integer
	if a < b then
		return 1
	elseif a > b then
		return -1
	end if
	return 0 '// a = b
end function

myList.CustomSort(@myCustomReverseSort) '// myCustomReverseSort will be used to sort myList from this
										'//  point on until .DefaultSort() or a different .CustomSort()
										'//  is used.
myList.Insert(9)

print "	After .Insert(9) with .CustomSort set to @myCustomReverseSort and .EnableSort:"
print "		"& myList.CSV() '// .CSV returns a comma separated string of all elements in the list
print
print " Use .DefaultSort() to revert to the default sorting method."
print
print "Press any key to close the example!"
sleep
