'// Typelist example
#include once "../fbList.bi"

print "Lists can be combined in a number of ways"

'// Create an array of numbers
dim as integer myFirstNumbers(...) = {1, 2, 3}
dim as integer mySecondNumbers(...) = {10, 20, 30}

'// Create a new list type named IntList that can hold integers
TypeList IntList Holds integer

'// Create a list off of our TYPELIST
dim as IntList myFirstList = myFirstNumbers(), mySecondList = mySecondNumbers()

print

print "	Our two integer lists:"
print "		"& myFirstList.CSV() '// .CSV returns a comma separated string of all elements in the list
print "		"& mySecondList.CSV() '// .CSV returns a comma separated string of all elements in the list
print

print " Lists can be easily combined using .Insert or += shorthand:"
myFirstList += mySecondList

print "	myFirstList after +=:"
print "		"& myFirstList.CSV() '// .CSV returns a comma separated string of all elements in the list

myFirstList.Clear( myFirstNumbers() ) '// Reset myFirstList
myFirstList.Insert(mySecondList, 1) '// Insert mySecondList into index 1

print "	myFirstList after .Insert( , 1):"
print "		"& myFirstList.CSV() '// .CSV returns a comma separated string of all elements in the list

print
print " 'foo'.Merge('bar', 'index') combines two lists, replacing 'foo' starting at 'index' and adds new elements"

myFirstList.Clear( myFirstNumbers() ) '// Reset myFirstList
myFirstList.Merge(mySecondList, 2) '// Merge overwrites myFirstList starting at index and allows myFirstList to grow

print "	myFirstList after .Merge( , 2), note how parts have been replaced and the list has grown in length:"
print "		"& myFirstList.CSV() '// .CSV returns a comma separated string of all elements in the list


print
print " 'foo'.Replace('bar', 'index') combines two lists, replacing 'foo' starting at 'index' but does not add new elements"

myFirstList.Clear( myFirstNumbers() ) '// Reset myFirstList
myFirstList.Replace(mySecondList, 2) '// Replace overwrites myFirstList starting at index and does NOT allow myFirstList to grow

print "	myFirstList after .Replace( , 2), note how parts have been replaced but the list has NOT grown in length:"
print "		"& myFirstList.CSV() '// .CSV returns a comma separated string of all elements in the list





print
print "Press any key to close the example!"
sleep
