'// Simple inventory example using an extended list
#include once "../fbList.bi"

type Item
	Name as string
	Amount as integer
	declare function Compare(b as Item) as integer	'// If declared will automatically be used by the Sorting and Find methods
end type
function Item.Compare(b as Item) as integer
	if this.Name = "Gold" or b.Name = "Gold" then '// We want gold to always be at the top
		if this.Name = b.Name then
			return 0
		end if
		if this.Name = "Gold" then
			return -1
		else
			return 1
		end if
	end if
	if this.Name < b.Name then
		return -1
	elseif this.Name > b.Name then
		return 1
	end if
	return 0
end function

TypeList InventoryType Holds Item ExtensionBegin
	declare function Pickup(byref iName as string, byval iAmount as integer = 1) as integer
	declare function Drop(byref iName as string, byval iAmount as integer = 1) as integer
	declare sub Show()
ExtensionEnd

sub InventoryType.Show()
	this.ForEach(i as integer)
		if this[i].Amount > 1 then
			print "["& i &"] "& this[i].Amount &" "& this[i].Name
		else
			print "["& i &"] "& this[i].Name
		end if
	next
end sub
function InventoryType.Drop(byref iName as string, byval iAmount as integer = 1) as integer
	dim as integer index = -1
	if iName <> "Gold" and iAmount > 1 then
		for g as integer = 1 to iAmount
			index = this.Drop(iName, 1)
		next
	else
		dim as Item matchItem
		matchItem.Name		=	iName
		
		index = this.Find(matchItem)
		if index > -1 then '// It's not a negative number so it was found in the list!
			this[index].Amount	-=	iAmount
			if this[index].Amount <= 0 then '// Remove it if we have none left
				this.Remove(index)
			end if
			if iAmount > 1 then
				print "Dropped "& iAmount &" "& iName
			else
				print "Dropped "& iName
			end if
		end if
	end if
	return index
end function
function InventoryType.Pickup(byref iName as string, byval iAmount as integer = 1) as integer
	dim as integer index = -1
	if iName <> "Gold" and iAmount > 1 then
		for g as integer = 1 to iAmount
			index = this.Pickup(iName, 1)
		next
	else
		dim as Item newItem
		newItem.Name	=	iName
		newItem.Amount	=	iAmount
		if iName = "Gold" then '// Let us stack gold
			index = this.Find(newItem)
			if index < 0 then '// Not found!
				index = this.Insert(newItem) '// Since we're not passing a pointer a copy will be created
			else
				this[index].Amount += iAmount
			end if
		else
			index = this.Insert(newItem) '// Since we're not passing a pointer a copy will be created
		end if
		if index < 0 then '// Something went wrong
			
		else
			if iAmount > 1 then
				print "Picked up "& iAmount &" "& iName
			else
				print "Picked up "& iName
			end if
		end if
	end if
	return index
end function


dim as InventoryType Inventory

Inventory.EnableSort()

Inventory.Pickup("Shiny boots")
Inventory.Pickup("Gold", 100)
Inventory.Pickup("Rusty sword")
Inventory.Pickup("Gold", 100)
Inventory.Pickup("Shiny boots")
Inventory.Pickup("Gold", 14)

print
print "Inventory:"
Inventory.Show()
print

Inventory.Drop("Shiny boots")
Inventory.Drop("Rusty sword")
Inventory.Drop("Gold", 14)
Inventory.Pickup("Arcane dagger")

print
print "Inventory:"
Inventory.Show()
print 


print
print "Press any key to complete your adventure!"
sleep
